{$A+,B-,D-,E-,F-,G-,I-,L-,N-,O-,R-,S-,V-,X-}
{$M 16384,0,655360}

program Draw3rd;


 uses

   CRT,
   Graph,
   Graph3rd;


 const

   VideoBuf        : pointer = ptr($B800, $0000);
   Count	   = 60;


 var

   F                         : file;
   B                         : array [1..20] of pointer;
   GD, GM, I                 : integer;
   X, Y, Fi, dX, dY, dFi     : real;


 procedure CGAProc; external;
  {$L CGA.Obj}

 function Z        (X, Y, Fi : real) : real;
  var
    R              : real;
  begin
    R              := Sqrt(X * X + Y * Y);
    Z              := Sin(R - Fi) / (R + 1);
  end;


 begin
   if RegisterBGIDriver(@CGAProc) = 0 then;
   GD              := CGA;
   GM              := CGAHi;
   InitGraph       (GD, GM, '');
   cmSetDirectVector         (0, 1, 1);
   cmSetMinX       (-18);
   cmSetMinY       (-18);
   cmSetMinZ       (-0.5);
   cmSetMaxX       (18);
   cmSetMaxY       (18);
   cmSetMaxZ       (0.5);
   dX              := Pi * 8 / Count;
   dY              := Pi * 8 / Count;
   dFi             := Pi / 10;
   cmRotateXY      (Pi / 80);
   Fi              := 0;
   Assign          (F, 'Graph3rd.Pic');
   ReWrite         (F, 1);
  for I := 1 to 20 do
  begin
    ClearViewPort;
    Y              := -4 * Pi;
   for GD := 0 to Count do
   begin
     X             := -4 * Pi;
     cmMoveTo3rd   (X, Y, Z(X, Y, Fi));
    for GM := 1 to Count do
    begin
      X            := X + dX;
      cmLineTo3rd  (X, Y, Z(X, Y, Fi));
    end;
     Y             := Y + dY;
   end;
    X              := -4 * Pi;
   for GD := 0 to Count do
   begin
     Y             := -4 * Pi;
     cmMoveTo3rd   (X, Y, Z(X, Y, Fi));
    for GM := 1 to Count do
    begin
      Y            := Y + dY;
      cmLineTo3rd  (X, Y, Z(X, Y, Fi));
    end;
     X             := X + dY;
   end;
    Fi             := Fi + dFi;
    cmRotateXY     (Pi / 40);
    GetMem         (B[I], $4000);
    Move           (VideoBuf^, B[I]^, $4000);
    BlockWrite     (F, B[I]^, $4000);
  end;
    Close          (F);
  while not KeyPressed do
  begin
   for I := 1 to 20 do
   begin
     Move          (B[I]^, VideoBuf^, $4000);
     Delay         (80);
   end;
  end;
   I               := Ord(ReadKey);
   CloseGraph;
 end.